package cc.glsn.v15.ga;

import java.util.Map;
import java.util.ArrayList;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Random;

import java.awt.Color;

import java.sql.ResultSet;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.DriverManager;

public class ImageGen implements FitnessTest
{

	public static void main(String args[])
		throws Exception
	{
		if (args.length > 0)
		{
			if (args[0].equals("inject"))
			{
				new Simulate("image_gen2", 8192, 65536, 3000000 ,200, 5, 35, 2, new ImageGen()).goInjectFresh();
				return;

			}
			if (args[0].equals("update_pop"))
			{
				updatePop();
				return;

			}

		}
		new Simulate("image_gen2", 8192, 65536, 3000000 ,400,2, 3, 2, new ImageGen()).goHuman();
		//new Simulate("image_gen2", 8192, 65536, 10000000 ,200, 5, 3, 2, new ImageGen()).goComputer();
		//new Simulate("image_gen2", 8192, 65536, 1000000 ,200, 10, 10, 2, new ImageGen()).goComputer();

	}

	public static void updatePop()
		throws java.sql.SQLException
	{
      	Connection conn =  DB.open();

			TreeSet<String> ids_in_pop=new TreeSet<String>();
			TreeSet<String> to_add=new TreeSet<String>();

			{
				PreparedStatement ps = conn.prepareStatement("select id from top");

				ResultSet r = ps.executeQuery();

				while(r.next())
				{
					ids_in_pop.add(r.getString("id"));
				}


				r.close();
				ps.close();


			}

			{
				PreparedStatement ps = conn.prepareStatement
					("select id from entity order by (votes_up/votes)*(votes_up/votes)*log10(if(votes>20,20,votes)) desc limit 40");

				ResultSet r = ps.executeQuery();

				while(r.next())
				{
					to_add.add(r.getString("id"));
				}

				ps.close();

			}

			for(String id : to_add)
			{
				if (!ids_in_pop.contains(id))
				{
					PreparedStatement ps = conn.prepareStatement
						("insert into top (id, project, instruction_data, fitness, generation, image) select id,project,instruction_data,fitness,generation,image from entity where id=?");
					ps.setString(1, id);

					ps.execute();
					ps.close();



				}
		
			}

		
		

	}

	public double findFitness(int mem[])
	{
		for(int i=0; i<mem.length; i++)
		{
			int z = mem[i];
			int mask = 0xFF000000;
			z = z | mask;
			mem[i] = z;
		}
		long nonzero = countNonZeros(mem);
		long unique = countUnique(mem);

		long score = nonzero * unique;
		for(int i=0; i<256; i++)
		for(int j=0; j<256; j++)
		{
			//score += similarButNotEqual(mem, i,j, i+1, j) * 2;
			//score += similarButNotEqual(mem, i,j, i+1, j+1) * 3;
			//score += similarButNotEqual(mem, i,j, i-1, j+1) * 3;
			//score += similarButNotEqual(mem, i,j, i, j+1) * 1;
			//bi.setRGB(i,j,last_mem[i*256+j]);
		}

		return (score);
		
	}

	private int similarButNotEqual(int mem[], int x1, int y1, int x2, int y2)
	{
		if (x2 >= 256) return 0;
		if (y2 >= 256) return 0;
		if (x2 < 0) return 0;
		if (y2 < 0) return 0;

		int x = mem[x1*256 + y1];
		int y = mem[x2*256 + y2];
		int d = colorDistance(x,y);

		if ((d >= 1) && (d <= 8)) return 1;
		return 0;


	}

	private int colorDistance(int c1, int c2)
	{
		Color c1c =new Color(c1, true);
		Color c2c = new Color(c2, true);

		int d=0;
		d+= Math.abs(c1c.getRed() - c2c.getRed());
		d+= Math.abs(c1c.getBlue() - c2c.getBlue());
		d+= Math.abs(c1c.getGreen() - c2c.getGreen());
		d+= Math.abs(c1c.getAlpha() - c2c.getAlpha());

		return d;

	}



	public static int countNonZeros(int mem[])
	{
		int n =0;
		int mask = 0x00FFFFFF;
		for(int i=0; i<mem.length; i++)
		{
			if ((mem[i] & mask) != 0) n++;
		}
		return n;
	}
	public static int countUnique(int mem[])
	{
		TreeSet<Integer> nums = new TreeSet<Integer>();

		for(int i=0; i<mem.length; i++)
		{
			nums.add(mem[i]);
		}
		return nums.size();
	}


}


